{###############################################################################
# Dipesh-AutoRun-32 V2
################################################################################
# Programmiert & Entwickelt von Sebastian Sauer (Dipesh)                       #
# in Borland/Inprise Delphi 3                                                  #
###############################################################################}

UNIT Edit;

INTERFACE

Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls, ExtCtrls, ComCtrls, FileCtrl;

Type
  TEditForm = class(TForm) // das "Bearbeiten"-Formular
    Page: TPageControl;
    TabEintraege: TTabSheet;
    TabAnsicht: TTabSheet;
    DarstellungPanel: TPanel;
    EintraegePanel: TPanel;
    TabInfos: TTabSheet;
    PanelInfos: TPanel;
    Panel1: TPanel;
    Image1: TImage;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label19: TLabel;
    ListView: TListView;
    Label26: TLabel;
    Label27: TLabel;
    ButtonBefehlWaehlen: TButton;
    ButtonHinzufuegen: TButton;
    ButtonOben: TButton;
    ButtonUnten: TButton;
    ButtonEntfernen: TButton;
    ButtonAlleMarkieren: TButton;
    ButtonKeineMarkieren: TButton;
    Label28: TLabel;
    ButtonSortieren: TButton;
    ImageList: TImageList;
    ComboBoxName: TComboBox;
    ComboBoxBefehl: TComboBox;
    Label29: TLabel;
    Image2: TImage;
    TabVerhalten: TTabSheet;
    Panel2: TPanel;
    CheckBoxSingleInstance: TCheckBox;
    CheckBoxNachAusfuehren: TCheckBox;
    CheckBoxHottrack: TCheckBox;
    PanelNachAusfuehren: TPanel;
    RadioButtonNachAusfuehrenBeenden: TRadioButton;
    RadioButtonNachAusfuehrenMinimieren: TRadioButton;
    Label4: TLabel;
    CheckBoxIcons: TCheckBox;
    PanelIcons: TPanel;
    RadioButtonIconsLarge: TRadioButton;
    RadioButtonIconsSmall: TRadioButton;
    Label5: TLabel;
    CheckBoxNachAusfuehrenMinimierenWiederherstellen: TCheckBox;
    CheckBoxNachAusfuehrenBeendenRueckfragen: TCheckBox;
    Label7: TLabel;
    CheckBoxBeiSchreibgeschuetzterIniDatei: TCheckBox;
    PanelSchreibgeschuetzt: TPanel;
    RadioButtonButtonPanelAusblenden: TRadioButton;
    RadioButtonButtonBearbeitenAusblenden: TRadioButton;
    TabAusfuehren: TTabSheet;
    TabHauptfenster: TTabSheet;
    TabDarstellung: TTabSheet;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    RadioButtonButtons: TRadioButton;
    LabelButtonHeight: TLabel;
    LabelButtonDistance: TLabel;
    LabelButtonLeft: TLabel;
    LabelButtonTop: TLabel;
    LabelIconsDistance: TLabel;
    LabelBtnLayout: TLabel;
    EditButtonHeight: TEdit;
    EditButtonDistance: TEdit;
    UpDownButtonHeight: TUpDown;
    UpDownButtonDistance: TUpDown;
    EditButtonLeft: TEdit;
    EditButtonTop: TEdit;
    UpDownButtonLeft: TUpDown;
    UpDownButtonTop: TUpDown;
    EditIconsDistance: TEdit;
    UpDownIconsDistance: TUpDown;
    ComboBoxBtnLayout: TComboBox;
    LabelListeColName: TLabel;
    LabelListeColBefehl: TLabel;
    RadioButtonListe: TRadioButton;
    CheckBoxListeShowCols: TCheckBox;
    EditListeColName: TEdit;
    EditListeColBefehl: TEdit;
    UpDownListeColName: TUpDown;
    UpDownListeColBefehl: TUpDown;
    ButtonColAktWerte: TButton;
    CheckBoxListeHeader: TCheckBox;
    CheckBoxListeWrapText: TCheckBox;
    CheckBoxListeGridlines: TCheckBox;
    GroupBoxPosHauptfenster: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    EditMainWidth: TEdit;
    EditMainHeight: TEdit;
    UpDownMainWidth: TUpDown;
    UpDownMainHeight: TUpDown;
    ButtonMainAktWerte: TButton;
    CheckBoxMaximieren: TCheckBox;
    Label8: TLabel;
    EditTitel: TEdit;
    Label30: TLabel;
    EditStartExec: TEdit;
    ComboBoxStartExecShowState: TComboBox;
    Label6: TLabel;
    EditCloseExec: TEdit;
    ComboBoxCloseExecShowState: TComboBox;
    CheckBoxStartExecExit: TCheckBox;
    Label1: TLabel;
    ComboBoxStartSound: TComboBox;
    LabelStatusbarAusrichtung: TLabel;
    CheckBoxStatuszeileZeigen: TCheckBox;
    ComboBoxStatusbarAusrichtung: TComboBox;
    ButtonAbbrechen: TButton;
    ButtonSpeichern: TButton;
    GroupBoxKommentar: TGroupBox;
    Label17: TLabel;
    EditKommentar: TEdit;
    EditKommentarHeight: TEdit;
    Label18: TLabel;
    UpDownKommentarHeight: TUpDown;
    ButtonKommentarAktWerte: TButton;
    // Formular
    procedure OnClose(Sender: TObject; var Action: TCloseAction);
    procedure OnCreate(Sender: TObject);
    procedure OnShow(Sender: TObject);
    procedure OnActivate(Sender: TObject);
    // Seite "Eintrge"
    procedure ListView_OnChange(Sender: TObject; Item: TListItem; Change: TItemChange);
    procedure ListView_OnMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ListView_OnDblClick(Sender: TObject);
    procedure ButtonSortieren_OnClick(Sender: TObject);
    procedure ButtonMarkieren_OnClick(Sender: TObject);
    procedure ButtonHinzufuegen_OnClick(Sender: TObject);
    procedure ButtonOben_OnClick(Sender: TObject);
    procedure ButtonUnten_OnClick(Sender: TObject);
    procedure ButtonEntfernen_OnClick(Sender: TObject);
    procedure ComboBox_OnEnter(Sender: TObject);
    procedure ComboBox_OnExit(Sender: TObject);
    procedure ComboBoxName_OnChange(Sender: TObject);
    procedure ComboBoxBefehl_OnChange(Sender: TObject);
    procedure ComboBoxName_OnDropDown(Sender: TObject);
    procedure ComboBoxBefehl_OnDropDown(Sender: TObject);
    procedure ButtonBefehlWaehlen_OnClick(Sender: TObject);
    // Alle anderen Seiten
    procedure CheckBoxStatuszeileZeigen_OnClick(Sender: TObject);
    procedure CheckBoxIcons_OnClick(Sender: TObject);
    procedure Darstellung_OnClick(Sender: TObject);
    procedure CheckBoxBeiSchreibgeschuetzterIniDatei_OnClick(Sender: TObject);
    procedure ButtonMainAktWerte_OnClick(Sender: TObject);
    procedure ButtonColAktWerte_OnClick(Sender: TObject);
    procedure ButtonKommentarAktWerte_OnClick(Sender: TObject);
    procedure EditStartExec_OnChange(Sender: TObject);
    procedure CheckBoxNachAusfuehrenBeenden_OnClick(Sender: TObject);    
    // Seite "Infos..."
    procedure LabelWeb_OnClick(Sender: TObject);
    procedure LabelWeb_OnMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure LabelWeb_OnMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    // Button "Speichern" OnClick
    procedure ButtonSpeichern_OnClick(Sender: TObject);
  private
    // Private
    function FindBrowser: string;
    function BrowserPath: string;
  end;

Var ModifiedByUser: boolean;
    ChangeDropDownItems: tstringlist;
    EditForm: TEditForm;

Const Page_Index: integer = 0;

IMPLEMENTATION

Uses Main, Change, List;

{$R *.DFM}

{-------------------------------------------------------------------------------
Formular
-------------------------------------------------------------------------------}

procedure TEditForm.OnClose(Sender: TObject; var Action: TCloseAction);
begin Page_Index:=Page.ActivePage.PageIndex; ChangeDropDownItems.Free; end;

procedure TEditForm.OnCreate(Sender: TObject);
begin Screen.Cursor:=crHourGlass; Page.ActivePage:=Page.Pages[Page_Index]; ChangeDropDownItems:=TStringList.Create; end;

procedure TEditForm.OnShow(Sender: TObject);
var i1, i2: integer; s1, s2: string; ListItem: TListItem;
begin
  ModifiedByUser:=false;
  // Seite "Eintrge"
  For i1:=0 to ItemLst.Count-1 do begin
    i2:=Pos('=',ItemLst[i1]); s1:=copy(ItemLst[i1],1,i2-1); s2:=copy(ItemLst[i1],i2+1,Length(ItemLst[i1])-i2);
    With ListView do begin ListItem:=Items.Add; ListItem.Caption:=s1; ListItem.SubItems.Add(s2); If i1=SelectedItem then ListItem.StateIndex:=0; end;
  end;
  // Seite "Darstellung"
  CheckBoxStatuszeileZeigen.Checked:=Statusbar_Show; CheckBoxStatuszeileZeigen_OnClick(nil); ComboBoxStatusbarAusrichtung.ItemIndex:=StatusBar_Alignment;
  CheckBoxHottrack.Checked:=ShowHotTrack;
  Case ShowIcons of 1: RadioButtonIconsSmall.Checked:=true; 2: RadioButtonIconsLarge.Checked:=true; else begin CheckBoxIcons.Checked:=false; CheckBoxIcons_OnClick(Sender); end; end;
  If (Assigned(ListForm))and(ListForm.Visible) then begin RadioButtonListe.Checked:=true; ButtonColAktWerte.Enabled:=true; CheckBoxListeShowCols.Checked:=ListForm.ListView.ViewStyle=vsReport;
  end else begin RadioButtonButtons.Checked:=true; ButtonColAktWerte.Enabled:=false; end;
  UpDownButtonLeft.Position:=BtnLeft; EditButtonLeft.Text:=IntToStr(UpDownButtonLeft.Position);
  UpDownButtonTop.Position:=BtnTop; EditButtonTop.Text:=IntToStr(UpDownButtonTop.Position);
  UpDownButtonHeight.Position:=BtnHeight; EditButtonHeight.Text:=IntToStr(UpDownButtonHeight.Position);
  UpDownButtonDistance.Position:=BtnDistance; EditButtonDistance.Text:=IntToStr(UpDownButtonDistance.Position);
  UpDownIconsDistance.Position:=BtnIconsDistance; EditIconsDistance.Text:=IntToStr(UpDownIconsDistance.Position);
  If (BtnIconsLayout>0)and(BtnIconsLayout<4) then ComboBoxBtnLayout.ItemIndex:=BtnIconsLayout else ComboBoxBtnLayout.ItemIndex:=0;
  CheckBoxListeGridlines.Checked:=ListGridLines;
  CheckBoxListeWrapText.Checked:=ListWrapText;
  CheckBoxListeHeader.Checked:=ListShowHeader;
  UpDownListeColName.Position:=ListColumnwidthName; EditListeColName.Text:=IntToStr(UpDownListeColName.Position);
  UpDownListeColBefehl.Position:=ListColumnwidthBefehl; EditListeColBefehl.Text:=IntToStr(UpDownListeColBefehl.Position);
  // alle anderen Seiten
  CheckBoxSingleInstance.Checked:=SingleInstance;
  If (HideIfReadOnly=1)or(HideIfReadOnly=2) then begin CheckBoxBeiSchreibgeschuetzterIniDatei.Checked:=true;
    Case HideIfReadOnly of 1: RadioButtonButtonBearbeitenAusblenden.Checked:=true; 2: RadioButtonButtonPanelAusblenden.Checked:=true; end;
    CheckBoxBeiSchreibgeschuetzterIniDatei_OnClick(Sender);
  end;
  EditTitel.Text:=MainForm.Caption;
  UpDownMainWidth.Position:=MainWidth; EditMainWidth.Text:=IntToStr(UpDownMainWidth.Position);
  UpDownMainHeight.Position:=MainHeight; EditMainHeight.Text:=IntToStr(UpDownMainHeight.Position);
  CheckBoxMaximieren.Checked:=MainShowMaximized;
  EditKommentar.Text:=KommentarTextDatei;
  If KommentarFeldHight>0 then begin UpDownKommentarHeight.Position:=KommentarFeldHight; EditKommentarHeight.Text:=IntToStr(KommentarFeldHight); end;
  ButtonKommentarAktWerte.Enabled:=MainForm.Memo.Visible;
  EditStartExec.Text:=ExecuteOnStart;
  If (ExecuteOnStart_ShowState>0)and(ExecuteOnStart_ShowState<ComboBoxStartExecShowState.Items.Count) then
    ComboBoxStartExecShowState.ItemIndex:=ExecuteOnStart_ShowState-1 else ComboBoxStartExecShowState.ItemIndex:=ComboBoxStartExecShowState.Items.Count-1;
  CheckBoxStartExecExit.Checked:=ExecuteOnStart_ExitAutorun;
  EditCloseExec.Text:=ExecuteOnExit;
  If (ExecuteOnExit_ShowState>0)and(ExecuteOnExit_ShowState<ComboBoxCloseExecShowState.Items.Count) then
    ComboBoxCloseExecShowState.ItemIndex:=ExecuteOnStart_ShowState-1 else ComboBoxCloseExecShowState.ItemIndex:=ComboBoxCloseExecShowState.Items.Count-1;
  Case PlaySoundOnStart of 1..5: ComboBoxStartSound.ItemIndex:=PlaySoundOnStart; else ComboBoxStartSound.ItemIndex:=0; end;
  Case AfterExecute of
    1..4: begin CheckBoxNachAusfuehren.Checked:=true; CheckBoxNachAusfuehrenBeenden_OnClick(Sender);
            Case AfterExecute of
              1,2: begin RadioButtonNachAusfuehrenMinimieren.Checked:=true; CheckBoxNachAusfuehrenMinimierenWiederherstellen.Checked:=AfterExecute=1; end;
              3,4: begin RadioButtonNachAusfuehrenBeenden.Checked:=true; CheckBoxNachAusfuehrenBeendenRueckfragen.Checked:=AfterExecute=3; end;
          end; end;
  end;
  // Seite "Infos..."
  Image1.Picture.Icon:=Application.Icon; Image2.Picture.Icon:=Application.Icon;
end;

procedure TEditForm.OnActivate(Sender: TObject);
begin Screen.Cursor:=crDefault; end;

{-------------------------------------------------------------------------------
Seite "Eintrge"
-------------------------------------------------------------------------------}

procedure TEditForm.ListView_OnChange(Sender: TObject; Item: TListItem; Change: TItemChange);
begin
  If ListView.Selected=nil then begin ComboBoxName.Text:=''; ComboBoxBefehl.Text:=''; end
  else begin ComboBoxName.Text:=ListView.Selected.Caption; ComboBoxBefehl.Text:=ListView.Selected.SubItems[0]; end;
end;

procedure TEditForm.ListView_OnMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin Case Button of mbRight: ListView_OnDblClick(Sender); end; end;

procedure TEditForm.ListView_OnDblClick(Sender: TObject);
var i1: integer;
begin
  If ListView.Selected=nil then Exit;
  For i1:=0 to ListView.Items.Count-1 do If ListView.Items[i1]<>ListView.Selected then If ListView.Items[i1].StateIndex=0 then ListView.Items[i1].StateIndex:=-1;
  If ListView.Selected.StateIndex=0 then ListView.Selected.StateIndex:=-1 else ListView.Selected.StateIndex:=0;
end;

procedure TEditForm.ButtonSortieren_OnClick(Sender: TObject);
begin ListView.AlphaSort; end;

procedure TEditForm.ButtonMarkieren_OnClick(Sender: TObject);
var i1: integer;
begin For i1:=0 to ListView.Items.Count-1 do ListView.Items[i1].Selected:=Sender<>ButtonKeineMarkieren; end;

procedure TEditForm.ButtonHinzufuegen_OnClick(Sender: TObject);
var s1, s2: string; ListItem: TListItem;
begin
  s1:=ComboBoxName.Text; s2:=ComboBoxBefehl.Text;
  If ListView.Selected=nil then ListItem:=ListView.Items.Add else begin
    ListItem:=ListView.Items.Insert(ListView.Selected.Index); ListView.Items[ListView.Selected.Index].Selected:=false; end;
  ListItem.Caption:=s1; ListItem.SubItems.Add(s2); ComboBoxName.SelStart:=0; ComboBoxName.SelLength:=Length(ComboBoxName.Text);
  ComboBoxBefehl.SelStart:=0; ComboBoxBefehl.SelLength:=Length(ComboBoxBefehl.Text); ListView.Selected:=ListItem;
end;

procedure TEditForm.ButtonOben_OnClick(Sender: TObject);
var i1, i2: integer; s1, s2: string;
begin
  If (ListView.Items.Count<2)or(ListView.Items[0].Selected) then Exit;
  For i1:=1 to ListView.Items.Count-1 do If ListView.Items[i1].Selected then begin
    s1:=ListView.Items[i1-1].Caption; s2:=ListView.Items[i1-1].SubItems[0]; i2:=ListView.Items[i1-1].StateIndex;
    ListView.Items[i1-1].Caption:=ListView.Items[i1].Caption; ListView.Items[i1-1].SubItems[0]:=ListView.Items[i1].SubItems[0]; ListView.Items[i1-1].StateIndex:=ListView.Items[i1].StateIndex;
    ListView.Items[i1].Caption:=s1; ListView.Items[i1].SubItems[0]:=s2; ListView.Items[i1].StateIndex:=i2;
    ListView.Items[i1-1].Selected:=true; ListView.Items[i1].Selected:=false;
  end;
end;

procedure TEditForm.ButtonUnten_OnClick(Sender: TObject);
var i1, i2: integer; s1, s2: string;
begin
  If (ListView.Items.Count<2)or(ListView.Items[ListView.Items.Count-1].Selected) then Exit;
  For i1:=ListView.Items.Count-2 downto 0 do If ListView.Items[i1].Selected then begin
    s1:=ListView.Items[i1+1].Caption; s2:=ListView.Items[i1+1].SubItems[0]; i2:=ListView.Items[i1+1].StateIndex;
    ListView.Items[i1+1].Caption:=ListView.Items[i1].Caption; ListView.Items[i1+1].SubItems[0]:=ListView.Items[i1].SubItems[0]; ListView.Items[i1+1].StateIndex:=ListView.Items[i1].StateIndex;
    ListView.Items[i1].Caption:=s1; ListView.Items[i1].SubItems[0]:=s2; ListView.Items[i1].StateIndex:=i2;
    ListView.Items[i1+1].Selected:=true; ListView.Items[i1].Selected:=false;
  end;
end;

procedure TEditForm.ButtonEntfernen_OnClick(Sender: TObject);
var i1: integer; s1: string;
begin
  Case ListView.SelCount of 0: Exit; 1: s1:='Soll der markierte Eintrag wirklich entfernt werden ?';
    else s1:='Sollen die '+IntToStr(ListView.SelCount)+' markierten Eintrge wirklich entfernt werden ?'; end;
  If MessageBox(0,PChar(s1),'Entfernen',MB_IconQuestion+MB_OkCancel+MB_SetForeground+MB_ApplModal)=idOk then begin
    For i1:=ListView.Items.Count-1 downto 0 do If ListView.Items[i1].Selected then ListView.Items[i1].Delete;
    If ListView.Selected<>nil then ListView.Selected.Delete;
  end;
end;

procedure TEditForm.ComboBox_OnEnter(Sender: TObject);
begin ModifiedByUser:=ListView.Selected<>nil; end;

procedure TEditForm.ComboBox_OnExit(Sender: TObject);
begin ModifiedByUser:=false; end;

procedure TEditForm.ComboBoxName_OnChange(Sender: TObject);
begin If (ModifiedByUser)and(ListView.Selected<>nil) then ListView.Selected.Caption:=ComboBoxName.Text; end;

procedure TEditForm.ComboBoxBefehl_OnChange(Sender: TObject);
begin If (ModifiedByUser)and(ListView.Selected<>nil) then ListView.Selected.SubItems[0]:=ComboBoxBefehl.Text; end;

procedure TEditForm.ComboBoxName_OnDropDown(Sender: TObject);
var i1, i2: integer; s1, s2, s3, s4: string;
begin
  ComboBoxName.Items.Clear; ComboBoxName.Items.Add(ComboBoxName.Text);
  s1:=Trim(ComboBoxBefehl.Text); If s1='' then Exit; ComboBoxName.Items.Add(s1);
  s2:=s1; i1:=MainForm.ExpandFileCom(s2,s3); If (i1<1)or(i1>2) then Exit; ComboBoxName.Items.Add(s2);
  If i1=1 then begin
    s3:=ExtractFileName(s2); ComboBoxName.Items.Add(s3); s4:=ExtractFileExt(s2); s1:=s3;
      If s4>'' then begin Delete(s1,Length(s1)-Length(s4)+1,Length(s4)); If s1>'' then ComboBoxName.Items.Add(s1); end;
    s3:=ExtractFilePath(s2);
  end else s3:=s2;
  If s3='' then Exit; If s3[Length(s3)]='\' then Delete(s3,Length(s3),1);
  Repeat s4:=s3;
    Repeat i2:=Pos('\',s4);
      If i2>0 then Delete(s4,1,i2) else begin If s4>'' then ComboBoxName.Items.Add(s4); Delete(s3,Length(s3)-Length(s4),Length(s4)+1); end;
    until i2=0;
  until Pos('\',s3)=0;
end;

procedure TEditForm.ComboBoxBefehl_OnDropDown(Sender: TObject);
var i1, i2: integer; s1, s2, s3, s4: string;
begin
  ComboBoxBefehl.Items.Clear; ComboBoxBefehl.Items.Add(ComboBoxBefehl.Text);
  s1:=Trim(ComboBoxBefehl.Text); If ComboBoxBefehl.Text<>s1 then ComboBoxBefehl.Items.Add(s1);
  i1:=MainForm.ExpandFileCom(s1,s2); If (i1<1)or(i1>3) then Exit;
  If i1<>3 then If Length(s1)>2 then begin s3:=LowerCase(ExtractFilePath(ParamStr(0))); s4:=s1;
    If Pos(s3,LowerCase(s1))=1 then begin Delete(s4,1,Length(s3));
      If s4>'' then begin If s4[1]<>'\' then s4:='\'+s4; ComboBoxBefehl.Items.Add(s4);
        Delete(s4,1,1); If s4>'' then If s4[Length(s4)]='\' then Delete(s4,Length(s4),1);
        Repeat s3:=s4;
          Repeat i2:=Pos('\',s3);
            If i2>0 then Delete(s3,1,i2) else begin Delete(s4,Length(s4)-Length(s3),Length(s3)+1); ComboBoxBefehl.Items.Add('\'+s4+'\'); end;
          until i2=0;
        until Pos('\',s4)=0;
  end; end; end;
  Case i1 of
    1,2: begin s3:=ExtractFilePath(s1); If s3>'' then ComboBoxBefehl.Items.Add(s3); If i1=1 then ComboBoxBefehl.Items.Add(s1); end;
    3: begin If s1>'' then ComboBoxBefehl.Items.Add(s1); If s2>'' then ComboBoxBefehl.Items.Add(s2); end;
  end;
end;

procedure TEditForm.ButtonBefehlWaehlen_OnClick(Sender: TObject);
var b1: boolean; s1: string;
begin
  With TChangeForm.Create(Self) do Try
    If ComboBoxBefehl.Text>'' then s1:=ComboBoxBefehl.Text else s1:=ExtractFilePath(ParamStr(0));
    If (not FileExists(s1))and(not DirectoryExists(s1)) then begin If s1>'' then If s1[1]='\' then Delete(s1,1,1);
      If (FileExists(ParamStr(0)[1]+':\'+s1))or(DirectoryExists(ParamStr(0)[1]+':\'+s1)) then s1:=ParamStr(0)[1]+':\'+s1 else
      If (FileExists(ExtractFilePath(ParamStr(0))+s1))or(DirectoryExists(ExtractFilePath(ParamStr(0))+s1)) then s1:=ExtractFilePath(ParamStr(0))+s1 else      s1:=ExtractFilePath(ParamStr(0));
    end;
    Try DirectoryListBox.Directory:=ExtractFilePath(s1); FileListBox.Filename:=ExtractFileName(s1); EditCom.Items:=ChangeDropDownItems; Except end;
    If ShowModal=mrOk then begin
      s1:=Trim(EditCom.Text);
      If Pos(LowerCase(ExtractFilePath(ParamStr(0))),LowerCase(s1))=1 then begin
        Delete(s1,1,Length(ExtractFilePath(ParamStr(0)))); If Length(s1)>0 then If s1[1]<>'\' then s1:='\'+s1;
      end else If Length(s1)>2 then If UpCase(s1[1])=UpCase(ParamStr(0)[1]) then Delete(s1,1,2);
      b1:=ModifiedByUser; ModifiedByUser:=true; ComboBoxBefehl.Text:=s1; ComboBoxBefehl_OnChange(Sender); ModifiedByUser:=b1;
    end;
  Finally Free; end;
end;

{-------------------------------------------------------------------------------
Alle anderen Seiten
-------------------------------------------------------------------------------}

procedure TEditForm.CheckBoxStatuszeileZeigen_OnClick(Sender: TObject);
begin LabelStatusbarAusrichtung.Enabled:=CheckBoxStatuszeileZeigen.Checked; ComboBoxStatusbarAusrichtung.Enabled:=CheckBoxStatuszeileZeigen.Checked; end;

procedure TEditForm.CheckBoxIcons_OnClick(Sender: TObject);
begin
  RadioButtonIconsSmall.Enabled:=CheckBoxIcons.Checked; RadioButtonIconsLarge.Enabled:=CheckBoxIcons.Checked;
  LabelIconsDistance.Enabled:=(CheckBoxIcons.Checked)and(RadioButtonButtons.Checked); EditIconsDistance.Enabled:=LabelIconsDistance.Enabled; UpDownIconsDistance.Enabled:=LabelIconsDistance.Enabled;
  LabelBtnLayout.Enabled:=LabelIconsDistance.Enabled; ComboBoxBtnLayout.Enabled:=LabelIconsDistance.Enabled;
end;

procedure TEditForm.Darstellung_OnClick(Sender: TObject);
begin
  // Buttons
  LabelButtonLeft.Enabled:=RadioButtonButtons.Checked; EditButtonLeft.Enabled:=RadioButtonButtons.Checked; UpDownButtonLeft.Enabled:=RadioButtonButtons.Checked;
  LabelButtonTop.Enabled:=RadioButtonButtons.Checked; EditButtonTop.Enabled:=RadioButtonButtons.Checked; UpDownButtonTop.Enabled:=RadioButtonButtons.Checked;
  LabelButtonHeight.Enabled:=RadioButtonButtons.Checked; EditButtonHeight.Enabled:=RadioButtonButtons.Checked; UpDownButtonHeight.Enabled:=RadioButtonButtons.Checked;
  LabelButtonDistance.Enabled:=RadioButtonButtons.Checked; EditButtonDistance.Enabled:=RadioButtonButtons.Checked; UpDownButtonDistance.Enabled:=RadioButtonButtons.Checked;
  LabelIconsDistance.Enabled:=(CheckBoxIcons.Checked)and(RadioButtonButtons.Checked); EditIconsDistance.Enabled:=LabelIconsDistance.Enabled; UpDownIconsDistance.Enabled:=LabelIconsDistance.Enabled;
  LabelBtnLayout.Enabled:=LabelIconsDistance.Enabled; ComboBoxBtnLayout.Enabled:=LabelIconsDistance.Enabled;
  // Liste
  CheckBoxListeGridlines.Enabled:=RadioButtonListe.Checked; CheckBoxListeWrapText.Enabled:=RadioButtonListe.Checked; CheckBoxListeShowCols.Enabled:=RadioButtonListe.Checked;
  CheckBoxListeHeader.Enabled:=(RadioButtonListe.Checked)and(CheckBoxListeShowCols.Checked); LabelListeColName.Enabled:=(RadioButtonListe.Checked)and(CheckBoxListeShowCols.Checked);
  EditListeColName.Enabled:=(RadioButtonListe.Checked)and(CheckBoxListeShowCols.Checked); UpDownListeColName.Enabled:=(RadioButtonListe.Checked)and(CheckBoxListeShowCols.Checked);
  LabelListeColBefehl.Enabled:=(RadioButtonListe.Checked)and(CheckBoxListeShowCols.Checked); EditListeColBefehl.Enabled:=(RadioButtonListe.Checked)and(CheckBoxListeShowCols.Checked);
  UpDownListeColBefehl.Enabled:=(RadioButtonListe.Checked)and(CheckBoxListeShowCols.Checked); ButtonColAktWerte.Enabled:=(RadioButtonListe.Checked)and(CheckBoxListeShowCols.Checked);;
end;

procedure TEditForm.CheckBoxBeiSchreibgeschuetzterIniDatei_OnClick(Sender: TObject);
begin
  RadioButtonButtonBearbeitenAusblenden.Enabled:=CheckBoxBeiSchreibgeschuetzterIniDatei.Checked;
  RadioButtonButtonPanelAusblenden.Enabled:=CheckBoxBeiSchreibgeschuetzterIniDatei.Checked;
end;

procedure TEditForm.ButtonMainAktWerte_OnClick(Sender: TObject);
begin
  If MainForm.WindowState=wsNormal then begin UpDownMainWidth.Position:=MainForm.Width; UpDownMainHeight.Position:=MainForm.Height; end;
  CheckBoxMaximieren.Checked:=MainForm.WindowState=wsMaximized;
end;

procedure TEditForm.ButtonColAktWerte_OnClick(Sender: TObject);
begin If Assigned(ListForm) then begin UpDownListeColName.Position:=ListForm.ListView.Columns[0].Width; UpDownListeColBefehl.Position:=ListForm.ListView.Columns[1].Width; end; end;

procedure TEditForm.ButtonKommentarAktWerte_OnClick(Sender: TObject);
begin UpDownKommentarHeight.Position:=MainForm.Memo.Height; end;

procedure TEditForm.EditStartExec_OnChange(Sender: TObject);
begin CheckBoxStartExecExit.Enabled:=Trim(EditStartExec.Text)>''; end;

procedure TEditForm.CheckBoxNachAusfuehrenBeenden_OnClick(Sender: TObject);
begin
  RadioButtonNachAusfuehrenMinimieren.Enabled:=CheckBoxNachAusfuehren.Checked;
  CheckBoxNachAusfuehrenMinimierenWiederherstellen.Enabled:=(CheckBoxNachAusfuehren.Checked)and(RadioButtonNachAusfuehrenMinimieren.Checked);
  RadioButtonNachAusfuehrenBeenden.Enabled:=CheckBoxNachAusfuehren.Checked;
  CheckBoxNachAusfuehrenBeendenRueckfragen.Enabled:=(CheckBoxNachAusfuehren.Checked)and(RadioButtonNachAusfuehrenBeenden.Checked);
end;

{-------------------------------------------------------------------------------
Seite "Infos..."
-------------------------------------------------------------------------------}

procedure TEditForm.LabelWeb_OnClick(Sender: TObject);
var s1: string;
begin
  s1:=BrowserPath;
  If s1='' then If MessageBox(0,'In ihrem System konnte kein Web-Browser gefunden werden.'+#13+'Denoch versuchen die Url auszufhren ?',
                                'Fehler: Browser nicht gefunden...',MB_IconQuestion+MB_OkCancel+MB_SetForeground+MB_ApplModal)<>mrOk then Exit;
  MainForm.ExecuteCom(s1+'|'+(Sender as TLabel).Caption,SW_SHOWNORMAL,false,true);
end;

procedure TEditForm.LabelWeb_OnMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin (Sender as TLabel).Font.Color:=clBlue; (Sender as TLabel).Update; end;

procedure TEditForm.LabelWeb_OnMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin (Sender as TLabel).Font.Color:=clWindowText; end;

{-------------------------------------------------------------------------------
Button "Speichern" OnClick
-------------------------------------------------------------------------------}

procedure TEditForm.ButtonSpeichern_OnClick(Sender: TObject);
var i1, i2: integer; file1: TextFile; // <-> Diese Variablen nochmal prfen, ob auch wirklich verwendet ! 
    ApplicationExeName_EXE2INI, s1: string;
begin
  ApplicationExeName_EXE2INI:=LowerCase(ExtractFileName(ParamStr(0)));
  ApplicationExeName_EXE2INI[1]:=UpCase(ApplicationExeName_EXE2INI[1]);
  s1:=ExtractFileExt(ApplicationExeName_EXE2INI);
  If s1>'' then begin
    Delete(ApplicationExeName_EXE2INI,Length(ApplicationExeName_EXE2INI)-Length(s1)+1,Length(s1));
    ApplicationExeName_EXE2INI:=ApplicationExeName_EXE2INI+'.ini'
  end else ApplicationExeName_EXE2INI:='Autorun.ini';
  // OpenDialog als SaveDialog mibraucht, hier wird nachgefragt in welcher Dipesh-Autorun-32 Ini-Datei gespeichert werden soll
  With MainForm.OpenDialog do begin
    Title:='Autorun.ini-Datei speichern unter...';
    InitialDir:=ExtractFilePath(ParamStr(0));
    Filename:=ApplicationExeName_EXE2INI;
    Options:=[ofHideReadOnly,ofPathMustExist,ofCreatePrompt];
    If Execute then IniFileCom:=ExpandFileName(Filename) else Exit;
  end;
  // Ini-Datei jetzt schreiben    
  Screen.Cursor:=crHourGlass;
  Try AssignFile(file1,IniFileCom); {$I-} Rewrite(file1); {$I+} i1:=IoResult;
    If i1<>0 then MessageBox(0,PChar('Die Ini-Datei "'+ExtractFileName(IniFileCom)+'"'+#13+'konnte nicht zum schreiben geffnet werden.'),'Fehler:',MB_IconStop+MB_Ok+MB_SetForeground+MB_ApplModal) else begin
      WriteLn(file1,IniFileCom_Pruefstring);
      WriteLn(file1); WriteLn(file1,'[Main]'); // -> [Main]
      WriteLn(file1,'Title='+EditTitel.Text); MainForm.Caption:=EditTitel.Text;
      SingleInstance:=CheckBoxSingleInstance.Checked; WriteLn(file1,'SingleInstance='+IntToStr(BoolToInteger(SingleInstance)));
      MainWidth:=UpDownMainWidth.Position; WriteLn(file1,'Width='+IntToStr(MainWidth)); MainForm.Width:=MainWidth;
      MainHeight:=UpDownMainHeight.Position; WriteLn(file1,'Height='+IntToStr(MainHeight)); MainForm.Height:=MainHeight;
      MainShowMaximized:=CheckBoxMaximieren.Checked; WriteLn(file1,'ShowMaximized='+IntToStr(BoolToInteger(MainShowMaximized)));
        If MainShowMaximized then MainForm.WindowState:=wsMaximized else MainForm.WindowState:=wsNormal;
      ShowHotTrack:=CheckBoxHottrack.Checked; WriteLn(file1,'HotTrack='+IntToStr(BoolToInteger(ShowHotTrack)));
      If not CheckBoxIcons.Checked then ShowIcons:=0 else If RadioButtonIconsSmall.Checked then ShowIcons:=1 else ShowIcons:=2; WriteLn(file1,'ShowIcons='+IntToStr(ShowIcons));
      If RadioButtonButtons.Checked then ViewStyle:=0 else If CheckBoxListeShowCols.Checked then ViewStyle:=2 else ViewStyle:=1; WriteLn(file1,'ViewStyle='+IntToStr(ViewStyle));
      ExecuteOnStart:=EditStartExec.Text; WriteLn(file1,'ExecuteOnStart='+ExecuteOnStart);
      ExecuteOnStart_ShowState:=ComboBoxStartExecShowState.ItemIndex+1; WriteLn(file1,'ExecuteOnStart ShowState='+IntToStr(ExecuteOnStart_ShowState));
      ExecuteOnStart_ExitAutorun:=CheckBoxStartExecExit.Checked; WriteLn(file1,'ExecuteOnStart ExitAutorun='+IntToStr(BoolToInteger(ExecuteOnStart_ExitAutorun)));
      ExecuteOnExit:=EditCloseExec.Text; WriteLn(file1,'ExecuteOnExit='+ExecuteOnExit);
      ExecuteOnExit_ShowState:=ComboBoxCloseExecShowState.ItemIndex+1; WriteLn(file1,'ExecuteOnExit ShowState='+IntToStr(ExecuteOnExit_ShowState));
      PlaySoundOnStart:=ComboBoxStartSound.ItemIndex; WriteLn(file1,'PlaySoundOnStart='+IntToStr(PlaySoundOnStart));
      KommentarTextDatei:=Trim(EditKommentar.Text); WriteLn(file1,'Comment Textfile='+KommentarTextDatei);
      KommentarFeldHight:=UpDownKommentarHeight.Position; WriteLn(file1,'Comment Height='+IntToStr(KommentarFeldHight));
      MainForm.SetKommentarMemo;
      Statusbar_Show:=CheckBoxStatuszeileZeigen.Checked; WriteLn(file1,'Statusbar Show='+IntToStr(BoolToInteger(Statusbar_Show)));
      Statusbar_Alignment:=ComboBoxStatusbarAusrichtung.ItemIndex; WriteLn(file1,'Statusbar Alignment='+IntToStr(Statusbar_Alignment));
        MainForm.SetStatusbarShowState;
      If CheckBoxBeiSchreibgeschuetzterIniDatei.Checked then begin If RadioButtonButtonBearbeitenAusblenden.Checked then HideIfReadOnly:=1 else HideIfReadOnly:=2; end
      else HideIfReadOnly:=0; WriteLn(file1,'HideIfReadOnly='+IntToStr(HideIfReadOnly));
      If CheckBoxNachAusfuehren.Checked then begin
        If RadioButtonNachAusfuehrenMinimieren.Checked then begin If CheckBoxNachAusfuehrenMinimierenWiederherstellen.Checked then AfterExecute:=1 else AfterExecute:=2; end
        else begin If CheckBoxNachAusfuehrenBeendenRueckfragen.Checked then AfterExecute:=3 else AfterExecute:=4; end;
      end else AfterExecute:=0; WriteLn(file1,'AfterExecute='+IntToStr(AfterExecute));
      BtnLeft:=UpDownButtonLeft.Position; WriteLn(file1,'Buttons Left='+IntToStr(BtnLeft));
      BtnTop:=UpDownButtonTop.Position; WriteLn(file1,'Buttons Top='+IntToStr(BtnTop));
      BtnHeight:=UpDownButtonHeight.Position; WriteLn(file1,'Buttons Height='+IntToStr(BtnHeight));
      BtnDistance:=UpDownButtonDistance.Position; WriteLn(file1,'Buttons Distance='+IntToStr(BtnDistance));
      BtnIconsDistance:=UpDownIconsDistance.Position; WriteLn(file1,'Buttons Spacing='+IntToStr(BtnIconsDistance));
      BtnIconsLayout:=ComboBoxBtnLayout.ItemIndex; WriteLn(file1,'Buttons Layout='+IntToStr(BtnIconsLayout));
      ListColumnwidthName:=UpDownListeColName.Position; WriteLn(file1,'List Columnwidth Name='+IntToStr(ListColumnwidthName));
      ListColumnwidthBefehl:=UpDownListeColBefehl.Position; WriteLn(file1,'List Columnwidth Befehl='+IntToStr(ListColumnwidthBefehl));
      ListShowHeader:=CheckBoxListeHeader.Checked; WriteLn(file1,'List ShowHeader='+IntToStr(BoolToInteger(ListShowHeader)));
      ListGridLines:=CheckBoxListeGridlines.Checked; WriteLn(file1,'List GridLines='+IntToStr(BoolToInteger(ListGridLines)));
      ListWrapText:=CheckBoxListeWrapText.Checked; WriteLn(file1,'List WrapText='+IntToStr(BoolToInteger(ListWrapText)));
        SelectedItem:=-1; For i2:=0 to ListView.Items.Count-1 do If ListView.Items[i2].StateIndex=0 then SelectedItem:=ListView.Items[i2].Index;
      WriteLn(file1,'SelectedItem='+IntToStr(SelectedItem));
      WriteLn(file1); WriteLn(file1,'[Items]'); ItemLst.Clear; // -> [Items]
      For i2:=0 to ListView.Items.Count-1 do begin
        ItemLst.Add(ListView.Items[i2].Caption+'='+ListView.Items[i2].SubItems[0]);
        WriteLn(file1,ListView.Items[i2].Caption+'='+ListView.Items[i2].SubItems[0]);
      end;
    end;
    // Nun wieder schlieen und damit die Datei auch physisch schreiben
    {$I-} Closefile(file1); {$I+} i2:=IoResult;
    If (i1=0)and(i2<>0) then begin
      MessageBox(0,PChar('Speichern von "'+ExtractFileName(IniFileCom)+'" fehlgeschlagen.'),'Fehler:',MB_IconStop+MB_Ok+MB_SetForeground+MB_ApplModal)
    end else begin
      If not FileExists(ExtractFilePath(ParamStr(0))+'AUTORUN.INF') then begin
        // Wenn noch keine Autorun.inf-Datei vorhanden ist, nachfragen ob eine erstellt werden soll
        If MessageBox(0,PChar('Die Autorun.inf-Datei mu sich im Stammverzeichnis eines Datentrgers/Laufwerkes'+#13+
                              'befinden, damit Dipesh-Autorun-32 beim einlegen des Datentrgers bzw. beim ausfhren'+#13+
                              'der Autorun-Funktion automatisch gestartet wird.'+#13+#13+
                              'Im Stammverzeichnis (Rootdir) des Datentrgers/Laufwerkes mssen sich folgende Dateien'+#13+
                              'befinden:'+#13+
                              '- die Autorun.inf (Autostart),'+#13+
                              '- diese Exe-Datei ('+ExtractFileName(ParamStr(0))+'),'+#13+
                              '- und die Ini-Datei ('+ApplicationExeName_EXE2INI+').'),
                              'Autorun.inf erstellen ?',MB_IconQuestion+MB_YesNo+MB_DefButton2+MB_SetForeground+MB_ApplModal)=idYes then begin
          AssignFile(file1,ExtractFilePath(ParamStr(0))+'Autorun.inf'); {$I-} Rewrite(file1); {$I+} i1:=IoResult;
          If i1<>0 then MessageBox(0,'Die Autorun.inf-Datei konnte nicht erstellt werden.','Fehler:',MB_IconStop+MB_Ok+MB_SetForeground+MB_ApplModal) else begin
            // Autorun.Inf-Datei schreiben
            WriteLn(file1,'[AUTORUN]');
            WriteLn(file1,'OPEN='+LowerCase(ExtractFileName(ParamStr(0))));
            WriteLn(file1,'ICON='+LowerCase(ExtractFileName(ParamStr(0)))+',0');
            WriteLn(file1);
            WriteLn(file1,'[NAME]');
            WriteLn(file1,'CAPTION='+MainForm.Caption);
          end;
          {$I-} Closefile(file1); {$I+}
          If (IoResult<>0)and(i1=0) then
            MessageBox(0,'Speichern von der Autorun.inf-Datei fehlgeschlagen.','Fehler:',MB_IconStop+MB_Ok+MB_SetForeground+MB_ApplModal)
        end;
      end;
      With MainForm do begin SetViewStyle(ViewStyle); SetItems; MainPanel_OnResize(nil); end; // Ansicht/Darstellung in TMainForm aktualisieren
      ModalResult:=mrOk;
    end;
  Finally Screen.Cursor:=crDefault; end;
end;

{-------------------------------------------------------------------------------
Private
-------------------------------------------------------------------------------}

// Der Quellcode der folgenden beiden Routine stammt aus der Freeware-Komponente GotoWeb 2.1
// von CRESTO Sylvain (cresto@mygale.org, http://www.mygale.org/~cresto/) - thanks CRESTO !
function TEditForm.FindBrowser: string;
var c: byte; hkey1,hkey2: hkey; typ,taille: integer; tmp: array[0..1024] of char;
const nbr_extension=4; extension: array[0..nbr_extension-1] of string=('.HTM','.HTML','.SHTML','.SHTM');
begin
  c:=0;
  Repeat
    if regopenkeyex(hkey_classes_root,pchar(extension[c]),0,key_all_access,hkey1)=0 then begin
      if regqueryvalueex(hkey1,nil,nil,@typ,nil,@taille)=error_success then begin
        regqueryvalueex(hkey1,nil,nil,nil,@tmp,@taille);
        if tmp<>'' then
          if regopenkeyex(hkey_classes_root,pchar(tmp+'\shell\open\command'),0,key_all_access,hkey2)=error_success then begin
            if regqueryvalueex(hkey2,nil,nil,@typ,nil,@taille)=error_success then begin regqueryvalueex(hkey2,nil,nil,nil,@tmp,@taille);
              if tmp<>'' then begin RegCloseKey(hkey2); FindBrowser:=strpas(tmp); Exit; end; end;
            regclosekey(hkey2);
          end;
        if regopenkeyex(hkey1,'shell\open\command',0,key_all_access,hkey2)=error_success then begin
          if regqueryvalueex(hkey2,nil,nil,@typ,nil,@taille)=error_success then begin regqueryvalueex(hkey2,nil,nil,nil,@tmp,@taille);
            if tmp<>'' then begin RegCloseKey(hkey2); FindBrowser:=strpas(tmp); Exit; end; end;
        end;
      end; regclosekey(hkey1);
    end; inc(c);
  until c=nbr_extension;
  FindBrowser:='';
end;

function TEditForm.BrowserPath: string;
var tmp, para: string; s,c: word;
begin
  tmp:=findbrowser;
  if tmp<>'' then begin c:=length(tmp)+1;
    repeat dec(c); para:=uppercase(copy(tmp,c-3,4)); until (para='.EXE') or (para='.BAT') or (para='.COM');
    if c<length(tmp) then begin s:=c; para:=trim(copy(tmp,c+1,length(tmp)-(c))); c:=1;
      while (c<=length(para)) do if para[c]='"' then delete(para,c,1) else inc(c);
      if para<>'' then begin c:=1;
        while c<=length(para) do begin
          if para[c]='%' then begin while (c<=length(para)) and (para[c]<>' ') do delete(para,c,1); end else inc(c); end;
      end;
      para:=trim(para); delete(tmp,s+1,length(tmp)-s);
    end else para:='';
    if tmp[1]='"' then delete(tmp,1,1);
  end;
  BrowserPath:=tmp;
end;

END.
